#|

PHASE 2 - RUNTIME
These files are loaded immediately after the runtime files are loaded, but before anything is done to create the initial user environment. Do not use these files to override runtime files. Rather, modify the runtime files and place the modified files in the runtime directory.

FILENAMES
Please use this naming convention for files in the update directory (where xxx is the original file name, when possible, and -mm-dd-yy is month-day-year of fix)

xxx-slt-mm-dd-yy.lsp  slot changes
xxx-fix-mm-dd-yy.lsp  bug fixes
xxx-bet-mm-dd-yy.lsp  betterments
xxx-new-mm-dd-yy.lsp  new features
xxx-mod-mm-dd-yy.lsp  modifications


SUBDIRECTORY NAME
Please name the subdirectory to identify the date of release of the changes. You must create a variable *update-subpath* whose value is a string which names the subdirectory. Do this with the following statement, substituting your subdirectory name (note use of back-quote and comma):

(setf *update-subpath* (make-pathname :directory `(:relative ,*update-path* "Sep23-2002")))


LOADING FILES
You should use the following statements to load files from the update subdirectory, substituting the appropriate filenames. Please include a comment explaining the update.

(mapcar #'(lambda (filename) (load (strcat *update-subpath* filename)))
        (list "datasmry-bet-09-03-02.lsp" ;changes about-these-data
              "datatype-fix-09-03-02.lsp" ;remove "checking for missing values"
              ))
|#
