
(DATA "Ed-Imported-Data" :TITLE "Dermatology" :ABOUT "1. Title: Dermatology Database
(a) Original owners:
-- 1. Nilsel Ilter, M.D., Ph.D., 
Gazi University, 
School of Medicine
06510 Ankara, Turkey
Phone: +90 (312) 214 1080
The differential diagnosis of erythemato-squamous diseases is a real
problem in dermatology. They all share the clinical features of
erythema and scaling, with very little differences. The diseases in
this group are psoriasis, seboreic dermatitis, lichen planus, 
pityriasis istopathological features. The values of the histopathological features
are determined by an analysis of the samples under a microscope. 
In the dataset constructed for this domain, the family history feature
has the value 1 if any of these diseases has been observed in the
family, and 0 otherwise. The age feature simply represents the age of
the patient. Every other feature (clinical and histopathological) was
given a degree in the range of 0 to 3. Here, 0 indicates that the
feature was not present, 3 indicates the largest amount possible,
and 1, 2 indicate the relative intermediate values.
-- Complete attribute documentation:
Clinical Attributes: (take values 0, 1, 2, 3, unless otherwise indicated: Variables 0 to 10 and variable 33.
Histopathological Attributes: (take values 0, 1, 2, 3): Variables 12 to 33
Class Distribution in variable Diagnostic: 1 psoriasis, 2 seboreic dermatitis, 3 lichen planus, 4 pityriasis rosea, 5 cronic dermatitis, 6 pityriasis rubra pilaris" :VARIABLES (QUOTE ("ERYTHEMA" "SCALING" "DEFINITE_BORDERS" "ITCHING" "KOEBNER_PHENOMENON" "POLYGONAL_PAPULES" "FOLLICULAR_PAPULES" "ORAL_MUCOSAL" "KNEE_AND_ELBOW_INVOLVEMENT" "SCALP_INVOLVEMENT" "FAMILY_HISTORY" "MELANIN_INCONTINENCE" "EOSINOPHILS_IN_THE_INFILTRATE" "PNL_INFILTRATE" "FIBROSIS_OF_THE_PAPILLARY_DERMIS" "EXOCYTOSIS" "ACANTHOSIS" "HYPERKERATOSIS" "PARAKERATOSIS" "CLUBBING_OF_THE_RETE_RIDGES" "ELONGATION_OF_THE_RETE_RIDGES" "THINNING_OF_THE_SUPRAPAPILLARY_EPIDERMIS" "SPONGIFORM_PUSTULE" "MUNRO_MICROABCESS" "FOCAL_HYPERGRANULOSIS" "DISAPPEARANCE_OF_THE_GRANULAR_LAYER" "VACUOLISATION_AND_DAMAGE_OF_BASAL_LAYER" "SPONGIOSIS" "SAW-TOOTH_APPEARANCE_OF_RETES" "FOLLICULAR_HORN_PLUG" "PERIFOLLICULAR_PARAKERATOSIS" "INFLAMMATORY_MONOLUCLEAR_INFLITRATE" "BAND-LIKE_INFILTRATE" "AGE" "Diagnosis")) :TYPES (QUOTE ("Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Numeric" "Category")) :LABELS (QUOTE ("Obs1" "Obs2" "Obs3" "Obs4" "Obs5" "Obs6" "Obs7" "Obs8" "Obs9" "Obs10" "Obs11" "Obs12" "Obs13" "Obs14" "Obs15" "Obs16" "Obs17" "Obs18" "Obs19" "Obs20" "Obs21" "Obs22" "Obs23" "Obs24" "Obs25" "Obs26" "Obs27" "Obs28" "Obs29" "Obs30" "Obs31" "Obs32" "Obs33" "Obs34" "Obs35" "Obs36" "Obs37" "Obs38" "Obs39" "Obs40" "Obs41" "Obs42" "Obs43" "Obs44" "Obs45" "Obs46" "Obs47" "Obs48" "Obs49" "Obs50" "Obs51" "Obs52" "Obs53" "Obs54" "Obs55" "Obs56" "Obs57" "Obs58" "Obs59" "Obs60" "Obs61" "Obs62" "Obs63" "Obs64" "Obs65" "Obs66" "Obs67" "Obs68" "Obs69" "Obs70" "Obs71" "Obs72" "Obs73" "Obs74" "Obs75" "Obs76" "Obs77" "Obs78" "Obs79" "Obs80" "Obs81" "Obs82" "Obs83" "Obs84" "Obs85" "Obs86" "Obs87" "Obs88" "Obs89" "Obs90" "Obs91" "Obs92" "Obs93" "Obs94" "Obs95" "Obs96" "Obs97" "Obs98" "Obs99" "Obs100" "Obs101" "Obs102" "Obs103" "Obs104" "Obs105" "Obs106" "Obs107" "Obs108" "Obs109" "Obs110" "Obs111" "Obs112" "Obs113" "Obs114" "Obs115" "Obs116" "Obs117" "Obs118" "Obs119" "Obs120" "Obs121" "Obs122" "Obs123" "Obs124" "Obs125" "Obs126" "Obs127" "Obs128" "Obs129" "Obs130" "Obs131" "Obs132" "Obs133" "Obs134" "Obs135" "Obs136" "Obs137" "Obs138" "Obs139" "Obs140" "Obs141" "Obs142" "Obs143" "Obs144" "Obs145" "Obs146" "Obs147" "Obs148" "Obs149" "Obs150" "Obs151" "Obs152" "Obs153" "Obs154" "Obs155" "Obs156" "Obs157" "Obs158" "Obs159" "Obs160" "Obs161" "Obs162" "Obs163" "Obs164" "Obs165" "Obs166" "Obs167" "Obs168" "Obs169" "Obs170" "Obs171" "Obs172" "Obs173" "Obs174" "Obs175" "Obs176" "Obs177" "Obs178" "Obs179" "Obs180" "Obs181" "Obs182" "Obs183" "Obs184" "Obs185" "Obs186" "Obs187" "Obs188" "Obs189" "Obs190" "Obs191" "Obs192" "Obs193" "Obs194" "Obs195" "Obs196" "Obs197" "Obs198" "Obs199" "Obs200" "Obs201" "Obs202" "Obs203" "Obs204" "Obs205" "Obs206" "Obs207" "Obs208" "Obs209" "Obs210" "Obs211" "Obs212" "Obs213" "Obs214" "Obs215" "Obs216" "Obs217" "Obs218" "Obs219" "Obs220" "Obs221" "Obs222" "Obs223" "Obs224" "Obs225" "Obs226" "Obs227" "Obs228" "Obs229" "Obs230" "Obs231" "Obs232" "Obs233" "Obs234" "Obs235" "Obs236" "Obs237" "Obs238" "Obs239" "Obs240" "Obs241" "Obs242" "Obs243" "Obs244" "Obs245" "Obs246" "Obs247" "Obs248" "Obs249" "Obs250" "Obs251" "Obs252" "Obs253" "Obs254" "Obs255" "Obs256" "Obs257" "Obs258" "Obs259" "Obs260" "Obs261" "Obs262" "Obs263" "Obs264" "Obs265" "Obs266" "Obs267" "Obs268" "Obs269" "Obs270" "Obs271" "Obs272" "Obs273" "Obs274" "Obs275" "Obs276" "Obs277" "Obs278" "Obs279" "Obs280" "Obs281" "Obs282" "Obs283" "Obs284" "Obs285" "Obs286" "Obs287" "Obs288" "Obs289" "Obs290" "Obs291" "Obs292" "Obs293" "Obs294" "Obs295" "Obs296" "Obs297" "Obs298" "Obs299" "Obs300" "Obs301" "Obs302" "Obs303" "Obs304" "Obs305" "Obs306" "Obs307" "Obs308" "Obs309" "Obs310" "Obs311" "Obs312" "Obs313" "Obs314" "Obs315" "Obs316" "Obs317" "Obs318" "Obs319" "Obs320" "Obs321" "Obs322" "Obs323" "Obs324" "Obs325" "Obs326" "Obs327" "Obs328" "Obs329" "Obs330" "Obs331" "Obs332" "Obs333" "Obs334" "Obs335" "Obs336" "Obs337" "Obs338" "Obs339" "Obs340" "Obs341" "Obs342" "Obs343" "Obs344" "Obs345" "Obs346" "Obs347" "Obs348" "Obs349" "Obs350" "Obs351" "Obs352" "Obs353" "Obs354" "Obs355" "Obs356" "Obs357" "Obs358" "Obs359" "Obs360" "Obs361" "Obs362" "Obs363" "Obs364" "Obs365" "Obs366")) :DATA (QUOTE (2.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 55.0 "2.00" 3.0 3.0 3.0 2.0 1.0 0.0 0.0 0.0 1.0 1.0 1.0 0.0 0.0 1.0 0.0 1.0 2.0 0.0 2.0 2.0 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 8.0 "1.00" 2.0 1.0 2.0 3.0 1.0 3.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 0.0 0.0 2.0 3.0 26.0 "3.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 2.0 0.0 3.0 2.0 2.0 2.0 2.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 40.0 "1.00" 2.0 3.0 2.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 3.0 2.0 3.0 0.0 0.0 2.0 3.0 45.0 "3.00" 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 41.0 "2.00" 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 18.0 "5.00" 2.0 2.0 3.0 3.0 3.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 3.0 2.0 0.0 0.0 3.0 3.0 57.0 "3.00" 2.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 22.0 "4.00" 2.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 30.0 "4.00" 3.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 3.0 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 20.0 "1.00" 2.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 21.0 "2.00" 3.0 3.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 3.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 22.0 "2.00" 2.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 1.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 10.0 "1.00" 2.0 2.0 3.0 3.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 3.0 0.0 0.0 1.0 3.0 65.0 "3.00" 1.0 1.0 0.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 40.0 "4.00" 2.0 2.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 30.0 "2.00" 3.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 3.0 1.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 3.0 3.0 3.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 38.0 "1.00" 2.0 1.0 3.0 3.0 3.0 3.0 0.0 0.0 2.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 3.0 0.0 0.0 2.0 3.0 23.0 "3.00" 1.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 2.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 17.0 "5.00" 2.0 1.0 1.0 2.0 0.0 0.0 3.0 0.0 1.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 1.0 2.0 2.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 1.0 0.0 8.0 "6.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 1.0 2.0 0.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 51.0 "2.00" 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 3.0 1.0 2.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 2.0 0.0 42.0 "5.00" 2.0 2.0 2.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 2.0 0.0 0.0 2.0 3.0 44.0 "3.00" 2.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 22.0 "5.00" 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 33.0 "1.00" 1.0 1.0 0.0 1.0 0.0 0.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 1.0 0.0 2.0 2.0 1.0 0.0 10.0 "6.00" 1.0 2.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 2.0 1.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 3.0 0.0 17.0 "5.00" 3.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 1.0 2.0 0.0 43.0 "2.00" 1.0 1.0 2.0 3.0 2.0 2.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 3.0 1.0 0.0 2.0 3.0 50.0 "3.00" 3.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 3.0 2.0 2.0 2.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 50.0 "1.00" 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 2.0 1.0 1.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 10.0 "2.00" 2.0 3.0 3.0 3.0 3.0 0.0 0.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 3.0 3.0 3.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 34.0 "1.00" 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 0.0 2.0 0.0 0.0 2.0 1.0 2.0 2.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 NIL "1.00" 2.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 NIL "4.00" 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 NIL "2.00" 2.0 1.0 2.0 3.0 2.0 3.0 0.0 2.0 0.0 0.0 1.0 1.0 0.0 0.0 0.0 2.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 NIL "3.00" 2.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 15.0 "2.00" 2.0 1.0 2.0 3.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 0.0 3.0 0.0 0.0 2.0 3.0 26.0 "3.00" 3.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 3.0 2.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 46.0 "1.00" 1.0 1.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 51.0 "2.00" 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 62.0 "4.00" 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 1.0 1.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 15.0 "1.00" 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 35.0 "2.00" 0.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 30.0 "5.00" 2.0 1.0 1.0 1.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 3.0 3.0 48.0 "3.00" 2.0 1.0 1.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 46.0 "4.00" 2.0 1.0 1.0 1.0 0.0 0.0 2.0 0.0 3.0 2.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 12.0 "6.00" 1.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 2.0 52.0 "2.00" 2.0 0.0 1.0 0.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 2.0 0.0 0.0 2.0 2.0 60.0 "3.00" 3.0 1.0 1.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 3.0 0.0 0.0 2.0 3.0 32.0 "3.00" 1.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 1.0 0.0 35.0 "4.00" 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 1.0 1.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 41.0 "1.00" 3.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 48.0 "1.00" 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 51.0 "5.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 2.0 1.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 19.0 "1.00" 1.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 22.0 "2.00" 2.0 1.0 1.0 3.0 0.0 3.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 1.0 0.0 0.0 2.0 2.0 29.0 "3.00" 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 25.0 "4.00" 3.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 33.0 "2.00" 2.0 2.0 1.0 1.0 0.0 0.0 1.0 0.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 1.0 2.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 1.0 0.0 8.0 "6.00" 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 40.0 "1.00" 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 33.0 "5.00" 3.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 3.0 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 42.0 "1.00" 2.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 36.0 "2.00" 3.0 2.0 2.0 2.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 1.0 3.0 60.0 "3.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 3.0 3.0 3.0 1.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 36.0 "1.00" 1.0 1.0 0.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 21.0 "4.00" 3.0 3.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 40.0 "5.00" 3.0 3.0 3.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 2.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 21.0 "1.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 34.0 "2.00" 2.0 1.0 2.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 3.0 0.0 0.0 13.0 "6.00" 1.0 1.0 1.0 1.0 1.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 2.0 3.0 52.0 "3.00" 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 48.0 "5.00" 2.0 1.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 17.0 "4.00" 3.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 25.0 "2.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 33.0 "2.00" 2.0 1.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 62.0 "1.00" 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 3.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 3.0 0.0 0.0 3.0 3.0 52.0 "3.00" 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 27.0 "5.00" 3.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 1.0 1.0 2.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 40.0 "1.00" 3.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 31.0 "2.00" 2.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 27.0 "2.00" 3.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 10.0 "2.00" 1.0 1.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 55.0 "5.00" 2.0 2.0 2.0 3.0 3.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 1.0 2.0 0.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 30.0 "1.00" 3.0 3.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 0.0 1.0 2.0 1.0 1.0 1.0 2.0 1.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 42.0 "1.00" 2.0 1.0 2.0 1.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 3.0 0.0 0.0 3.0 3.0 48.0 "3.00" 0.0 1.0 2.0 1.0 1.0 0.0 1.0 0.0 2.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 1.0 2.0 3.0 3.0 3.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 22.0 "1.00" 1.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 31.0 "4.00" 3.0 2.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 2.0 0.0 3.0 2.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 50.0 "2.00" 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 43.0 "2.00" 1.0 1.0 1.0 3.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 30.0 "5.00" 3.0 3.0 3.0 3.0 3.0 0.0 0.0 0.0 3.0 3.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 2.0 2.0 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 42.0 "1.00" 2.0 1.0 1.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 3.0 3.0 22.0 "3.00" 2.0 1.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 18.0 "4.00" 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 35.0 "2.00" 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 60.0 "5.00" 2.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 28.0 "1.00" 2.0 2.0 1.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 0.0 13.0 "6.00" 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 2.0 1.0 1.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 20.0 "2.00" 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 64.0 "5.00" 3.0 3.0 3.0 2.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 1.0 0.0 1.0 1.0 1.0 1.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 43.0 "1.00" 2.0 3.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 20.0 "2.00" 1.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 3.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 34.0 "2.00" 2.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 2.0 2.0 1.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 39.0 "1.00" 1.0 1.0 0.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 60.0 "4.00" 1.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 1.0 2.0 1.0 1.0 1.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 38.0 "1.00" 2.0 2.0 3.0 2.0 1.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 2.0 3.0 44.0 "3.00" 3.0 2.0 1.0 2.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 3.0 2.0 2.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 36.0 "1.00" 2.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 3.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 41.0 "1.00" 2.0 2.0 2.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 2.0 3.0 0.0 0.0 3.0 3.0 18.0 "3.00" 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 39.0 "5.00" 2.0 2.0 3.0 2.0 3.0 3.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 0.0 0.0 2.0 2.0 40.0 "3.00" 1.0 1.0 1.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 3.0 3.0 47.0 "3.00" 2.0 2.0 2.0 3.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 16.0 "5.00" 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 27.0 "2.00" 2.0 2.0 3.0 2.0 2.0 2.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 2.0 0.0 0.0 2.0 2.0 52.0 "3.00" 2.0 2.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 25.0 "4.00" 1.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 1.0 1.0 2.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 "1.00" 3.0 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 33.0 "2.00" 2.0 2.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 46.0 "5.00" 1.0 1.0 2.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 0.0 7.0 "6.00" 2.0 3.0 3.0 3.0 3.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 3.0 3.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 30.0 "1.00" 3.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 3.0 1.0 3.0 3.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 29.0 "1.00" 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 23.0 "2.00" 2.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 0.0 8.0 "6.00" 2.0 2.0 2.0 2.0 3.0 2.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 3.0 0.0 0.0 3.0 3.0 44.0 "3.00" 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 17.0 "5.00" 2.0 1.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 16.0 "4.00" 1.0 1.0 2.0 2.0 2.0 0.0 2.0 0.0 1.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 3.0 3.0 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 55.0 "1.00" 2.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 40.0 "1.00" 3.0 2.0 2.0 1.0 3.0 3.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 3.0 0.0 0.0 2.0 2.0 34.0 "3.00" 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 29.0 "5.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 34.0 "5.00" 1.0 1.0 1.0 1.0 1.0 0.0 1.0 0.0 2.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 1.0 2.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 25.0 "1.00" 2.0 2.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 70.0 "4.00" 3.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 37.0 "2.00" 2.0 3.0 2.0 3.0 3.0 3.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 0.0 0.0 2.0 2.0 41.0 "3.00" 3.0 3.0 3.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 1.0 1.0 2.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 32.0 "1.00" 2.0 2.0 1.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 20.0 "2.00" 2.0 3.0 1.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 19.0 "1.00" 3.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 1.0 2.0 3.0 3.0 3.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 61.0 "1.00" 2.0 1.0 1.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 2.0 2.0 0.0 0.0 3.0 2.0 27.0 "3.00" 1.0 1.0 2.0 3.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 2.0 3.0 0.0 0.0 2.0 3.0 36.0 "3.00" 2.0 2.0 3.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 3.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 1.0 2.0 0.0 0.0 2.0 3.0 40.0 "3.00" 3.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 52.0 "2.00" 1.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 3.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 27.0 "5.00" 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 30.0 "4.00" 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 45.0 "2.00" 1.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 34.0 "2.00" 2.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 1.0 2.0 1.0 0.0 0.0 1.0 0.0 2.0 1.0 0.0 1.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 27.0 "1.00" 3.0 3.0 2.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 1.0 0.0 2.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 46.0 "1.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 3.0 0.0 1.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 52.0 "1.00" 1.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 28.0 "5.00" 2.0 1.0 1.0 1.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 2.0 0.0 0.0 3.0 3.0 40.0 "3.00" 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 55.0 "2.00" 3.0 3.0 2.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 3.0 0.0 0.0 2.0 3.0 32.0 "3.00" 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 33.0 "2.00" 3.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 47.0 "2.00" 2.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 35.0 "4.00" 2.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 61.0 "2.00" 3.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 1.0 1.0 0.0 0.0 2.0 2.0 22.0 "3.00" 2.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 2.0 1.0 0.0 10.0 "6.00" 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 20.0 "2.00" 3.0 2.0 2.0 3.0 1.0 0.0 0.0 0.0 1.0 1.0 1.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 55.0 "1.00" 2.0 3.0 2.0 2.0 1.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 3.0 3.0 3.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 67.0 "1.00" 2.0 2.0 3.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 2.0 3.0 51.0 "3.00" 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 20.0 "4.00" 2.0 2.0 3.0 3.0 1.0 3.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 2.0 2.0 0.0 0.0 3.0 3.0 22.0 "3.00" 1.0 1.0 2.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 3.0 0.0 0.0 2.0 3.0 45.0 "3.00" 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 1.0 3.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 55.0 "1.00" 3.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 1.0 0.0 1.0 2.0 2.0 0.0 2.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 56.0 "1.00" 3.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 0.0 3.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 18.0 "1.00" 3.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 0.0 0.0 2.0 3.0 40.0 "3.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 2.0 3.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 30.0 "1.00" 3.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 3.0 3.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 33.0 "1.00" 2.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 40.0 "2.00" 1.0 2.0 2.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 0.0 0.0 2.0 2.0 42.0 "3.00" 2.0 2.0 2.0 2.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 3.0 3.0 0.0 0.0 2.0 2.0 36.0 "3.00" 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 27.0 "1.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 1.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 56.0 "1.00" 1.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 60.0 "1.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 3.0 0.0 3.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 20.0 "1.00" 2.0 2.0 1.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 2.0 0.0 7.0 "6.00" 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 30.0 "2.00" 3.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 19.0 "2.00" 2.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 52.0 "2.00" 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 55.0 "2.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 23.0 "1.00" 2.0 1.0 2.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 3.0 0.0 0.0 3.0 2.0 50.0 "3.00" 2.0 3.0 3.0 3.0 0.0 3.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 3.0 0.0 0.0 2.0 2.0 38.0 "3.00" 3.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 3.0 3.0 25.0 "3.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 3.0 3.0 2.0 2.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 18.0 "1.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 3.0 1.0 0.0 0.0 3.0 0.0 0.0 3.0 0.0 2.0 3.0 2.0 3.0 2.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 35.0 "1.00" 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 22.0 "2.00" 3.0 2.0 3.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 2.0 0.0 0.0 2.0 3.0 52.0 "3.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 50.0 "2.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 33.0 "2.00" 3.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 44.0 "2.00" 1.0 1.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 18.0 "5.00" 1.0 1.0 0.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 1.0 2.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 25.0 "5.00" 2.0 2.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 52.0 "5.00" 1.0 1.0 0.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 35.0 "5.00" 2.0 2.0 0.0 2.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 40.0 "5.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 3.0 2.0 1.0 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 55.0 "1.00" 2.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 3.0 1.0 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 20.0 "1.00" 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 3.0 2.0 2.0 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 60.0 "1.00" 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 33.0 "1.00" 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 3.0 2.0 3.0 2.0 2.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 27.0 "1.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 3.0 1.0 2.0 3.0 3.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 50.0 "1.00" 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 1.0 2.0 3.0 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 70.0 "1.00" 2.0 2.0 2.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 1.0 3.0 0.0 0.0 2.0 3.0 28.0 "3.00" 2.0 2.0 2.0 2.0 1.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 2.0 2.0 0.0 0.0 3.0 3.0 30.0 "3.00" 3.0 2.0 3.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 2.0 2.0 1.0 0.0 0.0 2.0 3.0 53.0 "3.00" 2.0 3.0 2.0 3.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 1.0 2.0 0.0 0.0 2.0 2.0 27.0 "3.00" 2.0 2.0 3.0 2.0 2.0 2.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 3.0 2.0 2.0 0.0 0.0 2.0 3.0 50.0 "3.00" 3.0 2.0 2.0 3.0 3.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 0.0 0.0 2.0 2.0 42.0 "3.00" 3.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 45.0 "4.00" 2.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 35.0 "4.00" 3.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 30.0 "4.00" 2.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 42.0 "4.00" 1.0 1.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 18.0 "5.00" 2.0 1.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 25.0 "5.00" 2.0 1.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 36.0 "5.00" 2.0 1.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 40.0 "5.00" 1.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 35.0 "5.00" 1.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 19.0 "5.00" 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 50.0 "5.00" 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 47.0 "2.00" 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 0.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 30.0 "2.00" 2.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 2.0 0.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 42.0 "2.00" 3.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 2.0 0.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 55.0 "2.00" 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 2.0 0.0 1.0 0.0 0.0 2.0 0.0 1.0 2.0 1.0 2.0 2.0 2.0 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 60.0 "1.00" 3.0 2.0 3.0 0.0 1.0 0.0 0.0 0.0 1.0 2.0 0.0 0.0 0.0 2.0 0.0 2.0 1.0 2.0 1.0 1.0 1.0 1.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 65.0 "1.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 1.0 0.0 2.0 1.0 2.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 47.0 "1.00" 3.0 2.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 35.0 "1.00" 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 1.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 52.0 "1.00" 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 3.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 60.0 "1.00" 2.0 2.0 2.0 1.0 0.0 0.0 2.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 0.0 7.0 "6.00" 3.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 3.0 3.0 0.0 8.0 "6.00" 2.0 2.0 2.0 3.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 3.0 3.0 3.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 25.0 "1.00" 3.0 2.0 2.0 3.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 60.0 "1.00" 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 3.0 0.0 3.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 50.0 "1.00" 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 2.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 33.0 "1.00" 3.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 0.0 3.0 3.0 3.0 3.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 27.0 "1.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 55.0 "1.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 62.0 "1.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 1.0 1.0 2.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 19.0 "1.00" 2.0 1.0 1.0 2.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 0.0 0.0 2.0 3.0 50.0 "3.00" 2.0 2.0 2.0 2.0 3.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 0.0 0.0 3.0 2.0 40.0 "3.00" 2.0 2.0 2.0 2.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 0.0 0.0 2.0 3.0 62.0 "3.00" 2.0 2.0 2.0 2.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 1.0 0.0 0.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 0.0 0.0 2.0 3.0 36.0 "3.00" 2.0 1.0 2.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 0.0 0.0 3.0 2.0 27.0 "3.00" 3.0 1.0 2.0 3.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 2.0 1.0 0.0 0.0 2.0 3.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 3.0 0.0 0.0 2.0 2.0 47.0 "3.00" 2.0 1.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 0.0 0.0 2.0 3.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 0.0 0.0 2.0 2.0 50.0 "3.00" 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 35.0 "4.00" 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 25.0 "4.00" 1.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 60.0 "4.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 22.0 "4.00" 1.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 35.0 "4.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 36.0 "4.00" 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 2.0 2.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 NIL "5.00" 1.0 1.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 3.0 1.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 NIL "5.00" 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 3.0 2.0 1.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 NIL "5.00" 1.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 1.0 1.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 NIL "5.00" 2.0 2.0 1.0 1.0 0.0 0.0 2.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 2.0 2.0 0.0 10.0 "6.00" 3.0 2.0 0.0 1.0 0.0 0.0 2.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 1.0 2.0 2.0 0.0 12.0 "6.00" 2.0 2.0 1.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 1.0 2.0 2.0 0.0 8.0 "6.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 35.0 "4.00" 2.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 62.0 "4.00" 2.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 48.0 "4.00" 3.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 3.0 3.0 3.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 30.0 "1.00" 2.0 2.0 3.0 1.0 0.0 0.0 0.0 0.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 3.0 3.0 3.0 2.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 57.0 "1.00" 1.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 3.0 3.0 3.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 62.0 "1.00" 2.0 2.0 3.0 1.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 3.0 3.0 2.0 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 36.0 "1.00" 3.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 3.0 2.0 3.0 2.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 18.0 "1.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 25.0 "2.00" 3.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 0.0 1.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 16.0 "2.00" 2.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 50.0 "4.00" 1.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 55.0 "4.00" 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 27.0 "4.00" 3.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 2.0 2.0 3.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 55.0 "1.00" 2.0 3.0 3.0 1.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 3.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 22.0 "1.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 70.0 "2.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 22.0 "2.00" 2.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 0.0 45.0 "2.00" 2.0 1.0 2.0 1.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 3.0 3.0 40.0 "3.00" 2.0 2.0 3.0 1.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 3.0 0.0 0.0 3.0 3.0 28.0 "3.00" 3.0 2.0 2.0 1.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 1.0 2.0 0.0 0.0 3.0 3.0 36.0 "3.00" 2.0 2.0 3.0 2.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 0.0 0.0 3.0 3.0 27.0 "3.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 2.0 3.0 3.0 2.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 42.0 "1.00" 2.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 3.0 2.0 1.0 0.0 0.0 1.0 0.0 0.0 3.0 0.0 2.0 2.0 3.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 27.0 "1.00" 2.0 2.0 3.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 3.0 3.0 2.0 2.0 2.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 50.0 "1.00" 2.0 1.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 3.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 34.0 "1.00" 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 8.0 "5.00" 2.0 1.0 1.0 3.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 19.0 "5.00" 1.0 1.0 2.0 2.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 3.0 2.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 36.0 "5.00" 2.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 70.0 "5.00" 2.0 2.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 1.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 52.0 "5.00" 2.0 2.0 3.0 3.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 2.0 0.0 0.0 2.0 3.0 25.0 "3.00" 3.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 3.0 0.0 0.0 3.0 3.0 36.0 "3.00" 2.0 2.0 2.0 3.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 3.0 0.0 0.0 1.0 2.0 50.0 "3.00" 2.0 1.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 34.0 "4.00" 3.0 1.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 17.0 "1.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 1.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 24.0 "1.00" 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 22.0 "4.00" 2.0 1.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 55.0 "4.00" 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 12.0 "4.00" 2.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 3.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 43.0 "1.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 3.0 2.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 50.0 "1.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 36.0 "1.00" 2.0 2.0 3.0 3.0 2.0 3.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 3.0 0.0 0.0 2.0 3.0 26.0 "3.00" 3.0 1.0 2.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 3.0 3.0 16.0 "3.00" 2.0 2.0 2.0 3.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 2.0 3.0 32.0 "3.00" 2.0 1.0 2.0 3.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 3.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 2.0 3.0 51.0 "3.00" 2.0 2.0 3.0 2.0 2.0 3.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 0.0 3.0 0.0 0.0 3.0 2.0 56.0 "3.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 2.0 3.0 2.0 3.0 1.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 47.0 "1.00" 2.0 2.0 3.0 1.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 3.0 3.0 3.0 2.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 51.0 "1.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 2.0 3.0 3.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 58.0 "1.00" 2.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 27.0 "1.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 32.0 "4.00" 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 27.0 "4.00" 2.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 62.0 "1.00" 2.0 2.0 3.0 0.0 1.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 1.0 1.0 2.0 2.0 2.0 3.0 0.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 53.0 "1.00" 3.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 46.0 "4.00" 2.0 1.0 2.0 3.0 2.0 2.0 0.0 3.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 1.0 2.0 0.0 0.0 2.0 3.0 37.0 "3.00" 1.0 1.0 2.0 3.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 2.0 3.0 49.0 "3.00" 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 2.0 0.0 18.0 "4.00" 2.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 3.0 2.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 46.0 "1.00" 2.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 2.0 3.0 2.0 3.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 33.0 "1.00" 1.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 0.0 22.0 "4.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 44.0 "4.00" 1.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 36.0 "5.00" 2.0 0.0 1.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 3.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 63.0 "5.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 2.0 3.0 2.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 56.0 "1.00" 2.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 2.0 3.0 2.0 1.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 60.0 "1.00" 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 3.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 42.0 "5.00" 3.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 32.0 "5.00" 2.0 1.0 2.0 2.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 2.0 3.0 51.0 "3.00" 2.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 33.0 "1.00" 1.0 1.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 2.0 0.0 1.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 68.0 "5.00" 2.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 50.0 "5.00" 2.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 3.0 2.0 2.0 0.0 9.0 "6.00" 2.0 2.0 1.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 2.0 3.0 1.0 0.0 16.0 "6.00" 2.0 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 35.0 "4.00" 2.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 40.0 "4.00" 2.0 2.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 2.0 2.0 2.0 0.0 22.0 "6.00" 3.0 2.0 2.0 0.0 0.0 0.0 3.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 3.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 3.0 2.0 2.0 0.0 10.0 "6.00" 2.0 2.0 1.0 0.0 0.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 2.0 0.0 7.0 "6.00" 1.0 2.0 2.0 2.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 1.0 3.0 3.0 3.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 25.0 "1.00" 2.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 2.0 3.0 1.0 0.0 0.0 1.0 0.0 0.0 2.0 2.0 2.0 2.0 2.0 2.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 9.0 "1.00" 3.0 2.0 2.0 3.0 2.0 0.0 0.0 0.0 2.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 2.0 3.0 2.0 0.0 3.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 55.0 "1.00" 1.0 1.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 2.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 45.0 "5.00" 2.0 0.0 1.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 1.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 56.0 "5.00" 2.0 3.0 2.0 3.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 2.0 3.0 2.0 2.0 2.0 0.0 3.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 36.0 "1.00" 2.0 2.0 2.0 2.0 2.0 0.0 0.0 0.0 3.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 3.0 3.0 0.0 2.0 0.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 75.0 "1.00" 2.0 2.0 2.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 3.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 45.0 "1.00" 2.0 3.0 2.0 1.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 2.0 2.0 2.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 24.0 "1.00" 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 1.0 0.0 40.0 "2.00" 2.0 2.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 1.0 0.0 2.0 2.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0 0.0 1.0 0.0 25.0 "2.00" 2.0 1.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 25.0 "4.00" 3.0 2.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0 0.0 0.0 2.0 0.0 36.0 "4.00" 3.0 2.0 2.0 2.0 3.0 2.0 0.0 2.0 0.0 0.0 0.0 2.0 2.0 0.0 0.0 3.0 3.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 3.0 0.0 3.0 0.0 0.0 2.0 3.0 28.0 "3.00" 2.0 1.0 3.0 1.0 2.0 3.0 0.0 2.0 0.0 0.0 0.0 2.0 0.0 0.0 0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 2.0 0.0 1.0 0.0 0.0 2.0 3.0 50.0 "3.00" 3.0 2.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 3.0 0.0 0.0 0.0 1.0 0.0 0.0 2.0 0.0 2.0 3.0 2.0 3.0 0.0 2.0 0.0 2.0 0.0 0.0 0.0 0.0 0.0 3.0 0.0 35.0 "1.00")) :DATASHEET-ARGUMENTS (QUOTE ((714 362) (57 167) 2 8))) 
